> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/utilities/isclaritytype.md).

# isClarityType

Type guard function for narrowing a generic `ClarityValue` to a specific Clarity type. Useful for runtime type checking of Clarity values returned from contract calls.

***

### Usage

```ts
import { isClarityType, ClarityType, Cl } from '@stacks/transactions';

const value: ClarityValue = Cl.uint(100);

if (isClarityType(value, ClarityType.UInt)) {
  // TypeScript now knows `value` is UIntCV
  console.log(value.value); // 100n
}

if (isClarityType(value, ClarityType.ResponseOk)) {
  // TypeScript now knows `value` is ResponseOkCV
  console.log(value.value); // inner ClarityValue
}
```

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/clarity/clarityValue.ts#L195)

***

### Signature

```ts
function isClarityType<T extends ClarityType>(
  val: ClarityValue,
  type: T
): val is ClarityTypetoValue[T];
```

***

### Returns

`boolean`

`true` if the value's type matches the provided `ClarityType`, with TypeScript type narrowing.

***

### Parameters

#### val (required)

* **Type**: `ClarityValue`

The Clarity value to check.

#### type (required)

* **Type**: `ClarityType`

The Clarity type to compare against.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/utilities/isclaritytype.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
